<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/29/2003 *
 * ===================                          Last change: 11/11/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : install-inc.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Functions for installation procedure             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die Installationsroutine         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

/************************************************************************
 *      YOU MAY ALSO WANT TO REMOVE THIS FILE AFTER INSTALLTION!        *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Init variables
$mysql = array();
if ((isPostRequestParameterSet('mysql')) && (is_array(postRequestParameter('mysql')))) {
	// Transfer 'mysql' array
	$mysql = postRequestParameter('mysql');
} // END - if

// Check if both passwords from SMTP are matching
if ((isGetRequestParameterSet('page') && (getRequestParameter('page') == 5))) {
	// Okay, we have to check it
	if (isPostRequestParameterSet('smtp_user') && (!isPostRequestParameterSet('smtp_host'))) {
		// Hostname not set
		addToInstallContent('<div class="para">' . getMessage('INSTALL_SMTP_HOSTNAME_EMPTY') . '</div>');
		setGetRequestParameter('page', 3);
	} // END - if

	if ((!isPostRequestParameterSet('smtp_pass1')) && (isPostRequestParameterSet('smtp_pass2'))) {
		// Password is empty
		addToInstallContent('<div class="para">' . getMessage('INSTALL_SMTP_PASS1_EMPTY') . '</div>');
		setGetRequestParameter('page', 3);
	} // END - if

	if ((isPostRequestParameterSet('smtp_pass1')) && (!isPostRequestParameterSet('smtp_pass2'))) {
		// Password repeat is empty
		addToInstallContent('<div class="para">' . getMessage('INSTALL_SMTP_PASS2_EMPTY') . '</div>');
		setGetRequestParameter('page', 3);
	} // END - if

	if (postRequestParameter('smtp_pass1') != postRequestParameter('smtp_pass1')) {
		// Passwords are not matching
		addToInstallContent('<div class="para">' . getMessage('INSTALL_SMTP_PASS_MISMATCH') . '</div>');
		setGetRequestParameter('page', 3);
	} // END - if
} // END - if

// Is the mailer installed or no admin registered so far?
if ((!isInstalled()) || (!isAdminRegistered())) {
	// Output page for entered value
	switch (getRequestParameter('page')) {
		case 'welcome': // Welcome to the installation!
			addTemplateToInstallContent('install_welcome');
			break;

		case '1': // Server path, base URL
			// Load template
			addTemplateToInstallContent('install_page1');
			break;

		case '2': // MySQL data (alone!)
			if (empty($mysql['dbase']))  $mysql['dbase']  = 'your_database';
			if (empty($mysql['login']))  $mysql['login']  = 'your_login';
			if (empty($mysql['host']))   $mysql['host']   = 'localhost';
			if (empty($mysql['prefix'])) $mysql['prefix'] = 'mxchange';
			if (empty($mysql['type']))   $mysql['type']   = 'MyISAM';
			if (getTotalFatalErrors() > 0) {
				addToInstallContent('<div class="install_fatal">');
				foreach (getFatalArray() as $key => $err) {
					addToInstallContent('<div class="para"><strong>&middot;</strong>&nbsp;{--FATAL_NO--}' . ($key + 1) . ':&nbsp;' . $err . '</div>');
				}
				addToInstallContent('</div>');
			}
			$content['mysql_host']   = $mysql['host'];
			$content['mysql_dbase']  = $mysql['dbase'];
			$content['mysql_prefix'] = $mysql['prefix'];
			$content['mysql_login']  = $mysql['login'];
			$content['table_type']   = $mysql['type'];
			$content['spath']        = postRequestParameter('spath');
			$content['burl']         = postRequestParameter('burl');
			$content['title']        = postRequestParameter('title');
			$content['slogan']       = postRequestParameter('slogan');
			$content['email']        = postRequestParameter('email');

			// Load template
			addTemplateToInstallContent('install_page2', $content);
			break;

		case '3':
			// Set more values
			$content['spath']      = postRequestParameter('spath');
			$content['burl']       = postRequestParameter('burl');
			$content['title']      = postRequestParameter('title');
			$content['slogan']     = postRequestParameter('slogan');
			$content['email']      = postRequestParameter('email');

			// Use default SMTP data
			$smtpHost  = getConfig('SMTP_HOSTNAME');
			$smtpUser  = getConfig('SMTP_USER');
			$smtpPass1 = getConfig('SMTP_PASSWORD');
			$smtpPass2 = getConfig('SMTP_PASSWORD');

			// Overwrite it with the data from sent (failed) form
			if (isPostRequestParameterSet('smtp_host')) $smtpHost = postRequestParameter('smtp_host');
			if (isPostRequestParameterSet('smtp_user')) $smtpUser = postRequestParameter('smtp_user');
			if (isPostRequestParameterSet('smtp_pass')) {
				$smtpPass1 = postRequestParameter('smtp_pass');
				$smtpPass2 = postRequestParameter('smtp_pass');
			} // END - if

			// MySQL settings
			$content['mysql_host']   = $mysql['host'];
			$content['mysql_dbase']  = $mysql['dbase'];
			$content['mysql_prefix'] = $mysql['prefix'];
			$content['table_type']   = $mysql['type'];
			$content['mysql_login']  = $mysql['login'];
			$content['mysql_pass1']  = $mysql['pass1'];
			$content['mysql_pass2']  = $mysql['pass2'];

			// Set constants for SMTP data
			$content['smtp_host']  = $smtpHost;
			$content['smtp_user']  = $smtpUser;
			$content['smtp_pass1'] = $smtpPass1;
			$content['smtp_pass2'] = $smtpPass2;

			// Load template
			addTemplateToInstallContent('install_page3', $content);
			break;

		case '5': // Misc settings
			// General settings
			$content['spath']  = postRequestParameter('spath');
			$content['burl']   = postRequestParameter('burl');
			$content['title']  = postRequestParameter('title');
			$content['slogan'] = postRequestParameter('slogan');
			$content['email']  = postRequestParameter('email');

			// SMTP settings
			$content['smtp_host'] = postRequestParameter('smtp_host');
			$content['smtp_user'] = postRequestParameter('smtp_user');
			$content['smtp_pass'] = postRequestParameter('smtp_pass1');

			// MySQL data
			$OUT = '';
			foreach ($mysql as $key => $value) {
				$OUT .= "    <input type=\"hidden\" name=\"mysql[" . $key . "]\" value=\"" . $value . "\" />\n";
			} // END - foreach
			$content['mysql_hidden'] = $OUT;

			// Load template
			addTemplateToInstallContent('install_page5', $content);
			break;

		case 'finalize': // Write captured data to files
			if ((isPostRequestParameterSet('finalize')) && (!isInstalled())) {
				// You have submitted data then we have to reset the SQLs
				initSqls();

				// Connect to MySQL server
				SQL_CONNECT($mysql['host'], $mysql['login'], $mysql['pass1'], __FILE__, __LINE__);
				if (SQL_IS_LINK_UP()) {
					// Seems to work, also right database?
					if (SQL_SELECT_DB($mysql['dbase'], __FILE__, __LINE__) === true) {
						// Automatically run install.sql
						if ((!isFileReadable(postRequestParameter('spath') . 'install/tables.sql')) || (!isFileReadable(postRequestParameter('spath') . 'install/menu-'.getLanguage().'.sql'))) {
							// Installation area not found!
							addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_MISSING_DUMPS'));
						} // END - if

						if (getTotalFatalErrors() == '0') {
							// Set type and prefix from POST data
							setConfigEntry('_TABLE_TYPE'  , postRequestParameter('mysql', 'type'));
							setConfigEntry('_MYSQL_PREFIX', postRequestParameter('mysql', 'prefix'));

							// Both exists so import them
							foreach (array('tables', 'menu-'.getLanguage()) as $dump) {
								// Should be save here because file_exists() is there but we check it again. :)
								$FQFN = postRequestParameter('spath') . 'install/' . $dump . '.sql';

								// Is the file readable?
								if (isFileReadable($FQFN)) {
									// Read the file
									$fileContent = readSqlDump($FQFN);

									// Split it up against ";\n" and merge it into existing SQLs
									mergeSqls(explode(";\n", $fileContent), 'install');
								} else {
									// Not readable!
									debug_report_bug(sprintf("SQL dump %s is not readable!", $dump));
								}
							} // END - foreach
							//* DEBUG: */ die('<pre>'.print_r(getSqls(), true).'</pre>');

							// Are some SQLs found?
							if (countSqls() == '0') {
								// Abort here
								addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_SQL_IMPORT_FAILED'));
								return;
							} // END - if

							// Now run all queries through and try to keep out empty or comment queries
							runFilterChain('run_sqls');

							// Copy the config template and verify it
							doInstallWriteLocalConfig();
						} // END - if
					} // END - if
				} // END - if

				if (getTotalFatalErrors() > 0) {
					$OUT = '';
					foreach (getFatalArray() as $value) {
						$OUT .= '    <li>' . $value . '</li>';
					} // END foreach
					$content['fatal_errors'] = $OUT;
					$OUT = '';
					foreach ($mysql as $key => $value) {
						$OUT .= '    <input type="hidden" name="mysql[' . $key . ']" value="' . $value . '" />';
					} // END foreach
					$content['mysql_hidden'] = $OUT;
					$content['spath']      = postRequestParameter('spath');
					$content['burl']       = postRequestParameter('burl');
					$content['title']      = postRequestParameter('title');
					$content['smtp_host']  = postRequestParameter('smtp_host');
					$content['smtp_user']  = postRequestParameter('smtp_user');
					$content['smtp_pass']  = postRequestParameter('smtp_pass1');

					// Load template
					addTemplateToInstallContent('install_fatal_errors', $content);
				} else {
					// Installation is done!
					redirectToUrl('install.php?page=finished');
				}
			} else {
				// Something goes wrong during installation! :-(
				addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_FINALIZER_FAILED'));
			}
			break;

		case 'finished':
			if (isInstalled()) {
				// Load template that we are finished
				addTemplateToInstallContent('install_finished');
			} else {
				// Not finished
				redirectToUrl('install.php');
			}
			break;

		default:
			logDebugMessage(__FILE__, __LINE__, sprintf("Wrong page %s detected", getRequestParameter('page')));
			addTemplateToInstallContent('admin_settings_saved', '<div class="install_error">{--WRONG_PAGE--}</div>');
			break;
	} // END - switch
} else {
	// Already installed!
	addFatalMessage(__FILE__, __LINE__, getMessage('ALREADY_INSTALLED'));
}

// [EOF]
?>
