<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 01/29/2008 *
 * ===================                          Last change: 01/29/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-user_contct.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Contact the user over a form                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Das Mitglied ueber ein Formular kontaktieren     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Is a user id given?
if ((isGetRequestParameterSet('userid')) && (bigintval(getRequestParameter('userid')) > 0)) {
	// Is a user account found?
	if (fetchUserData(getRequestParameter('userid'))) {
		// Load the data
		$content = getUserDataArray();

		// Including user id
		$content['userid'] = bigintval(getRequestParameter('userid'));

		// Shall we send the email?
		if (isFormSent()) {
			// Insert text
			$content['text'] = trim(secureString(postRequestParameter('text')));

			// Send contact form out
			$message = loadEmailTemplate('member_contct', $content);
			sendEmail($content['email'], getMessage('ADMIN_CONTACT_USER_SUBJECT'), $message);
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_USER_CONTACTED'));
		} else {
			// Load contact form template
			loadTemplate('admin_contct_user_form', false, $content);
		}
	} else {
		// Not found?
		loadTemplate('admin_settings_saved', false, getMaskedMessage('USER_ACCOUNT_404', bigintval(getRequestParameter('userid'))));
	}
} else {
	// Display selection box
	addMemberSelectionBox();
}

// [EOF]
?>
