<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/17/2008 *
 * ===================                          Last change: 09/17/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_list.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Surfbar URL statistics                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Surfbar-Statistiken                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('surfbar')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('surfbar'));
	return;
} // END - if

// Load user URLs
$URLs = SURFBAR_GET_USER_URLS();

// Are there entries or form is submitted?
if ((isFormSent()) && (isPostRequestParameterSet(('action'))) && (isPostRequestParameterSet('id'))) {
	// Process the form
	if (SURFBAR_MEMBER_DO_FORM(postRequestArray(), $URLs)) {
		// Action performed but shall we display it?
		if (((postRequestParameter('action') != 'edit') && (postRequestParameter('action') != "delete")) || (isPostRequestParameterSet(('execute')))) {
			// Display "action done" message if action is wether 'edit' nor 'delete' or has been executed
			loadTemplate('admin_settings_saved', false, getMessage('MEMBER_SURFBAR_ACTION_DONE'));
		} // END - if
	} else {
		// Something went wrong
		loadTemplate('admin_settings_saved', false, getMessage('MEMBER_SURFBAR_ACTION_FAILED'));
	}
} elseif (count($URLs) > 0) {
	// List all URLs
	$OUT = ''; $SW = 2;
	foreach ($URLs as $id => $content) {
		// "Translate"/insert data
		$content['sw'] = $SW;
		$content['url'] = generateDerefererUrl($content['url']);
		if ($content['views_total'] > 0) {
			// Include link to stats
			$content['views_total'] = "[<a href=\"{%url=modules.php?module=login&amp;what=surfbar_list%}\">".translateComma($content['views_total'])."</a>]";
		} // END - if
		$content['registered']  = generateDateTime($content['registered'], 2);
		$content['last_locked'] = generateDateTime($content['last_locked'], 2);
		$content['actions']     = SURFBAR_MEMBER_ACTIONS($content['id'], $content['status']);
		$content['status']      = translateSurfbarUrlStatus($content['status']);
		if (empty($content['lock_reason'])) {
			// Fixes some HTML problems with empty cells
			$content['lock_reason'] = '---';
		} // END - if

		// Load row template
		$OUT .= loadTemplate('member_surfbar_list_row', true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - if

	// Load main template
	loadTemplate('member_surfbar_list', false, $OUT);
} else {
	// No URLs booked so far
	loadTemplate('admin_settings_saved', false, getMessage('MEMBER_SURFBAR_NO_URLS_FOUND'));
}

//
?>
